<?php

/**
 * Definition of the mailq custom mail backend to collect all mails 
 * into the mailq queue to be processed later in cron runs.
 * This will get enabled only when not running crons.
 */
function drupal_mail_wrapper(&$message) {
  if (MAILQ_DEBUG_MODE) {
    watchdog(
      'mailq',
      'Queued mail to @to with message id @id and subject @subject',
      array(
        '@to' => $message['to'],
        '@id' => $message['id'],
        '@subject' => $message['subject'],
      ),
      WATCHDOG_DEBUG
    );
  }
  // Place this into the queue
  $current_smtp_lib = variable_get('mailq_send_library', '');
  $headers = serialize($message['headers']);
  $drupal_sender = variable_get('site_mail', 'drupal@localhost');
  $queued = db_query(
    "INSERT INTO {mailq_active_queue} ".
      "(".
        "mailkey, sender, recpt, ".
        "subject, message, queue_date, queue_sent, ".
        "queue_attempts, queue_engine_used, queue_status ".
      ") ".
      "VALUES ".
      "(".
        "'%s', '%s', '%s', ".
        "'%s', '%s', %d, %d, ".
        "%d, '%s', %d ".
      ") ",
    $message['id'], $message['from'], $message['to'],
    $message['subject'], serialize($message), time(), 0,
    0, $current_smtp_lib, MAILQ_STATUS_QUEUED
  );
  return $queued;
}
